<?php
class ModelExtensionPaymentBirb extends Model {
	public function getMethod() {
		$this->load->language('extension/payment/birb');
		$method_data = array(
			'code' => 'birb',
			'title' => $this->language->get('text_title'),
			'terms'      => '',
			'sort_order' => $this->config->get('payment_birb_sort_order'),
			'html'      => '<select id="crypto_lkm"  name="crypto"><option value="birb" selected="selected">Birb</option><option value="busd">BUSD</option></select>',
			
		);
		

		return $method_data;
	}
	public function addOrder($order_data) {
		
		$this->db->query("INSERT INTO `" . DB_PREFIX . "birb_order` SET 
		`order_id` = '" . (int)$order_data['storeOrderId'] . "',
		`created` = NOW(), `modified` = NOW(),
		`debug_data` = '" . json_encode($order_data) . "', 
		`total` = '" . (int)$order_data['total'] . "', 
		`payment` = false,  
		`coin` = '" . $order_data['coin'] . "',
		`currency` = '" . $order_data['currency'] . "',
		`platformId` = '" . $order_data['platformId'] . "',
		`birbId` = '" . $order_data['_id'] . "',
		`transaction_id` = ''");
			 
		return $this->db->getLastId();
	}
	public function addTransaction($order_data) {
		
		$hasAlready = $this->db->query("SELECT * FROM " . DB_PREFIX . "birb_transactions WHERE order_id = '" . (int)$order_data->storeOrderId . "'");
		
		// var_dump($hasAlready);die;
		if(!$hasAlready->num_rows){
		$this->db->query("INSERT INTO `" . DB_PREFIX . "birb_transactions` SET 
		`order_id` = '" . (int)$order_data->storeOrderId . "',
		`created` = NOW(), `modified` = NOW(),
		`debug_data` = '" . json_encode($order_data) . "', 
		`total` = '" . (float)$order_data->coin . "', 
		`to` = 'merchant-address',
		`from` = '',
		`fromaddress` = '',
		`hash` = '" . $order_data->hash . "',
		`coin` = '" . $order_data->coin . "',
		`platformId` = '" . $order_data->platformId . "',
		`birbId` = '" . $order_data->_id . "',
		`transaction_id` =  '" . $order_data->_id . "' ");
			 
		return $this->db->getLastId();
		} else{
		$this->db->query("UPDATE  `" . DB_PREFIX . "birb_transactions` SET
		`created` = NOW(), `modified` = NOW(),
		`debug_data` = '" . json_encode($order_data) . "', 
		`total` = '" . (float)$order_data->coin . "', 
		`to` = '',
		`from` = '',
		`fromaddress` = '',
		`hash` = '" . $order_data->hash . "',
		`coin` = '" . $order_data->coin . "',
		`platformId` = '" . $order_data->platformId . "',
		`birbId` = '" . $order_data->_id . "',
		`transaction_id` =  '" . $order_data->_id . "'
		WHERE order_id = '" . (int)$order_data->storeOrderId . "'");
			 
		return $this->db->getLastId();
		}
	}

	

	public function updateOrder($order_id) {
		$this->db->query("UPDATE " . DB_PREFIX . "birb_order SET	payment = true WHERE order_id = '" . (int)$order_id . "'");
	}
	public function updateOrderStatus($order_id, $status) {
		$this->db->query("UPDATE " . DB_PREFIX . "order SET	order_status_id = '".$status ."' WHERE order_id = '" . (int)$order_id . "'");
	}

	
	public function getBirbOrder($order_id) {
		
		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "birb_order WHERE order_id = '" . (int)$order_id . "'");

		return $query->rows;
	}
	public function getTransaction($order_id) {
		//var_dump($order_id);die;
		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "birb_transactions WHERE order_id = '" . (int)$order_id . "' ORDER BY id DESC");
		//var_dump($query->rows);die;
		return $query->rows;
	}

	

	

}
